<?php

/* mailbox.php: main page that displays the message list for the selected mailbox 
*
    Copyright (C) 2002  Hastymail Development group

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; Version 2
    See the COPYING file for complete information.

* $Id: mailbox.php,v 1.239 2003/10/22 15:50:54 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'mailbox');

/* Login to Hastymail */
if (isset($hm_input['login'])) {
    $imap_stream = hm_hastymail_login($hm_input, $config_file, $hasty_key);
    $config = $_SESSION['config'];
    $str = $_SESSION['str'];

    /* get the folder list */
    $_SESSION['folders'] = hm_boxlist($imap_stream, true, 'all');

    /* very first time we are logging in, check for autocreate folder
       settings */
    if (isset($_SESSION['first_login'])) {
        require_once('../lib/imap_3.php');
        hm_autocreate_folders($imap_stream, $config);
        hm_write_settings($_SESSION['user'], $config['settings_dir']); 
    }
    if (!isset($_SESSION['dsp_folders'])) {
        $_SESSION['dsp_folders'] = hm_folder_dsp($_SESSION['folders']);
    }

    /* check for trash/sent/drafts settings and make sure the folders
       exist */
    $write = false;
    $warning = '';
    $specials = array('trash_folder', 'sent_folder', 'drafts_folder');
    foreach ($specials as $val) {
        if (isset($_SESSION['settings'][$val]) &&
            !in_array(urldecode($_SESSION['settings'][$val]), $_SESSION['folders'])) {
            unset($_SESSION['settings'][$val]);
            $write = true;
            $warning .= $str[27].'<br>';
        }
    }
    if ($write) {
        hm_write_settings($_SESSION['user'], $config['settings_dir']);
    }

    /* redirect to non-standard start page */
    if (isset($_SESSION['settings']['start_page']) && 
        $_SESSION['settings']['start_page'] != '' &&
        $_SESSION['settings']['start_page'] != 'mailbox.php') {
        hm_imap_logout($imap_stream);
        header("Location: ".$_SESSION['config']['hostname'].
                $_SESSION['config']['install_path'].
                $_SESSION['settings']['start_page'].
                '?id='.session_id().'&amp;mailbox=INBOX');
        exit;
    }
}
else {
    hm_session_continue($hm_input['id'], $config_file);
    $config = $_SESSION['config'];
    $str = $_SESSION['str'];
    if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                      $hasty_key, false, false)) {
        hm_logged_out($config_file); 
    } 
    $write = false;
    $warning = '';
    $specials = array('trash_folder', 'sent_folder', 'drafts_folder');
    foreach ($specials as $val) {
        if (isset($_SESSION['settings'][$val]) &&
            !in_array(urldecode($_SESSION['settings'][$val]), $_SESSION['folders'])) {
            unset($_SESSION['settings'][$val]);
            $write = true;
            $warning .= $str[27].'<br>';
        }
    }
    if ($write) {
        hm_write_settings($_SESSION['user'], $config['settings_dir']);
    }
}
$config = $_SESSION['config'];
$hm_input['id'] = session_id();
$sort_types = $str['sort_types'];
if (isset($hm_input['destination'])) {
    $dest = $hm_input['destination'];
}
elseif (isset($_SESSION['move_to_destination'])) {
    $dest = $_SESSION['move_to_destination'];
}
else {
    $dest = 'INBOX';
}
$_SESSION['move_to_destination'] = $dest;


/* check for simple option and set flag */
$simple = false;
if (isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true') {
    $simple = true;
}

/* select the mailbox for imap */
hm_select_mailbox($imap_stream, $hm_input['mailbox']);

/* check to see if we loaded this page from a prev/next button */
if (isset($hm_input['prev']) && isset($hm_input['submit']) && 
    $hm_input['submit'] == '<<<') {
    $hm_input['page_num'] = $hm_input['prev'];
}
elseif (isset($hm_input['next']) && isset($hm_input['submit']) && 
        $hm_input['submit'] == '>>>') {
    $hm_input['page_num'] = $hm_input['next'];
}
elseif (isset($hm_input['submit']) && $hm_input['submit'] == $str[9]) {
    $hm_input['page_num'] = $hm_input['page'];
}
elseif (isset($hm_input['submit2']) && $hm_input['submit2'] == $str[9]) {
    $hm_input['page_num'] = $hm_input['page2'];
}
elseif (!isset($hm_input['page_num'])) {
    $hm_input['page_num'] = 0;
}

/* if we are moving/copying/deleting/etc. messages */
$resort = false;
$large = false;
$sort = false;
$action_dsp = '';
$err_flag = false;

if (isset($hm_input['action2'])) {
    $hm_input['action'] = $hm_input['action2'];
    $hm_input['selection_type'] = $hm_input['selection_type2'];
    $hm_input['destination'] = $hm_input['destination2'];
    $hm_input['sort_type'] = $hm_input['sort_type2'];
}

if (!isset($hm_input['uid_string'])) {
    $uid_string = '';
}
else {
    $uid_string = $hm_input['uid_string'];
}
if (isset($hm_input['action']) && $hm_input['action'] == $str[20]) {
    $hm_input['selection_type'] = 'all';
    $hm_input['action'] = $str[4];
}
if (isset($hm_input['action'])) {
    if (isset($hm_input['selection_type'])) {
        if ($hm_input['selection_type'] == 'marked') {
            $dsp_count = 0;
            foreach($_POST as $index => $value) {
                if ($value == 'mark') {
                    $dsp_count++;
                    $uid_string .= $index.',';
                }
            }
        }
        elseif($hm_input['selection_type'] == 'page') {
            $dsp_count = count(split(",", $hm_input['page_string']));
            $uid_string = $hm_input['page_string'];
        }
        elseif($hm_input['selection_type'] == 'all') {
            $sort_tmp = $_SESSION['sort_data'][$hm_input['mailbox']];
            $dsp_count = count($sort_tmp[2]);
            if ($dsp_count > 1000) {
                $large = $hm_input['mailbox'];
            }
            $uid_string = implode(',', $sort_tmp[2]);
            unset($sort_tmp);
        }
    }
    elseif (isset($hm_input['uid_delete'])) {
        $dsp_count = 1;
        $uid_string = $hm_input['uid_delete'];
    }
    elseif (isset($hm_input['uid_move'])) {
        $dsp_count = 1;
        $uid_string = $hm_input['uid_move'];
    }
    if ($dsp_count > 1) {
        $dsp_end = $str[18];
    }
    else {
        $dsp_end = $str[26];
    }
    $srt = false;
    if (isset($hm_input['sort_type'])) {
        $srt = $hm_input['sort_type'];
    }
    if (!isset($hm_input['destination'])) {
        $hm_input['destination'] = '';
    }
    $result = hm_message_controls ($hm_input['action'], $imap_stream, $uid_string, 
                                   $hm_input['destination'], $large, $srt, 
                                   $hm_input['mailbox'], $dsp_count, $dsp_end);
    $action_dsp = $result[0];
    $err_flag = $result[1];
    $sort = $result[2];
    $resort = $result[3];
}

/* update counts and check the cache */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);
$cache = hm_check_cache($hm_input['mailbox']);

/* get the sort information for this mailbox/page */
if ($sort) {
    $_SESSION['settings']['sort'][$hm_input['mailbox']] = $sort;
}
if (isset($_SESSION['settings']['sort']) 
          && array_key_exists($hm_input['mailbox'], $_SESSION['settings']['sort'])) {
    $sort = $_SESSION['settings']['sort'][$hm_input['mailbox']];
} 
else {
    $sort = 'ARRIVAL';
}
if ($cache && !$resort) {
    $sort_info = $_SESSION['sort_data'][$hm_input['mailbox']];
}
else {
    if (isset($_SESSION['thread_data'][$hm_input['mailbox']])) {
        unset($_SESSION['thread_data'][$hm_input['mailbox']]);
    }
    $sort_info = hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox']);
}   

/* toolbar and any status messages */
hm_toolbar($imap_stream, $hm_input['mailbox'], $unseen, false, 
           urldecode($hm_input['mailbox']));

/* check for login warning */
if ($warning != '') {
    echo '<br><table align="center" class="tables3">
   <tr>
     <td align="center">
     ',$warning,'
      </td>
   </tr>
</table>',"\n";
}


/* check for redirect from message.php for a message that could not opened */
if (isset($_SESSION['del_error']) && $_SESSION['del_error'] != '') {
    echo '<br><table align="center" class="tables3">
   <tr>
     <td align="center">
     ',$_SESSION['del_error'],'
      </td>
   </tr>
</table>',"\n";
    $_SESSION['del_error'] = '';
    unset($_SESSION['del_error']);
}

/* create the contols for the top of the message table */
echo '<form action="mailbox.php" method="post">',"\n";
if ($sort_info != '') {
    if (!array_key_exists($hm_input['page_num'], $sort_info[1])) {
        $hm_input['page_num'] = 0;
    }
    $dsp_folders = $_SESSION['dsp_folders'];
if (!$simple) {
    echo '
<table width="98%" align="center" cellpadding="2" cellspacing="4" class="tables5">
   <tr>
      <td>
      <table width="100%" align="center" cellpadding="1" cellspacing="6" class="tables5">
         <tr>
            <td class="tables4" width="15%" nowrap>
            &nbsp;&nbsp;&nbsp;',$dsp_folders[urldecode($hm_input['mailbox'])],'
            </td>
            <td class="tables1" nowrap>
             &nbsp;&nbsp;',"\n";
}
if ($hm_input['page_num'] > 0) {
    echo '            <input type=submit name="submit" ',
                              "class=\"button2\" value=\"<<<\">\n";
    $hm_input['prev'] = $hm_input['page_num'] - 1;
    echo '            <input type="hidden" name="prev" value="',$hm_input['prev'],'">
            <input type="hidden" name="id" value="',$hm_input['id'],'">
            <input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'">',"\n";
}
elseif (!$simple) {
    echo '            <input type="button" disabled="disabled" ',
                             "value=\"<<<\" class=\"button3\">\n";
}
echo '            <input type="submit" name="submit" value="',$str[9],
         '" class="button2">
            <select name="page">',"\n";
foreach ($sort_info[1] as $index => $array) {
    echo "              <option value=\"$index\" ";
    if ($index == $hm_input['page_num']) {
        echo 'SELECTED';
    }
    echo " >",($index+1),"</option>\n";
}
echo "            </select>\n";
if ($sort_info[0] > $sort_info[1][$hm_input['page_num']][1]) { 
    $next = $hm_input['page_num'] + 1;
    echo '            <input type="submit" name="submit" class="button2" ',
             'value=">>>">
            <input type="hidden" name="next" value="',$next,'">
            <input type="hidden" name="id" value="',$hm_input['id'],'">
            <input type="hidden" name="mailbox" value="',$hm_input['mailbox'],"\">\n";
}
elseif (!$simple) {
    echo '            &nbsp;<input type="button" disabled="disabled" ',
                             "value=\">>>\" class=\"button3\">\n";
}
if (!$simple) {
    echo "            </td>\n";
    if ($action_dsp != '') {
        if ($err_flag) {
            echo '
            <td align="center" width="20%" class="tables3">
            <font color="red"><small>',$action_dsp,'</small></font>
            </td>
            <td class="tables1" width="30%" align="right" nowrap>',"\n";
        }
        else {
            echo '
            <td align="center" width="20%" class="tables3">
            <font class="font2"><small>',$action_dsp,'</small></font>
            </td>
            <td class="tables1" width="40%" align="right" nowrap>',"\n";
        }
    }
    else {
        echo "            <td class=\"tables1\" width=\"15%\" align=\"right\" nowrap>\n";
    }
}
elseif ($action_dsp != '') {
    echo '&nbsp;&nbsp;&nbsp;',$action_dsp,'&nbsp;&nbsp;&nbsp;';
}
echo '            <input type="submit" class="button2" name="action" value="',$str[17],'">
            <select name="sort_type">',"\n";
if (isset($_SESSION['config']['client_sort']) && 
          $_SESSION['config']['client_sort'] == 'true') {
    $sort_types = $str['client_sort_types'];
}
foreach ($sort_types as $key => $value) {
    echo '               <option ';
    if ($sort == $key) {
        echo ' SELECTED ';
    }    
    echo "value=\"$key\">$value</option>\n";
}
echo '            </select>&nbsp;',"\n";

/* get the message headers */
$headers = hm_get_messages (implode(',', $sort_info[1][$hm_input['page_num']][2]), 
                                $imap_stream);
    
/* some hidden fields and the top message controls */
$count = count($headers);
$sort_page = $sort_info[1][$hm_input['page_num']][2];
echo '            <input type="hidden" name="id" value="',$hm_input['id'],'">
            <input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'">
            <input type="hidden" name="page_string" value="', implode(',', $sort_page),'">
            <input type="hidden" name="page_num" value="',$hm_input['page_num'],'">',"\n";
if (!$simple) {
    echo '            </td>
         </tr>
      </table>
      </td>
   </tr>
   <tr>
      <td>
      <table width="100%" align="center" cellpadding="1" cellspacing="0" class="tables0">
         <tr>
            <td colspan="6" class="tables0">
            <table width="100%" class="tables0" align="center" cellpadding="4" cellspacing="0">
               <tr>
                  <td nowrap>';
    }
    echo '
                  <b><small>&nbsp;&nbsp;&nbsp;',$sort_info[0],' ',$str[18],
        ' &nbsp;&nbsp;',$str[19],' ',$sort_info[1][$hm_input['page_num']][0],' - ', 
        $sort_info[1][$hm_input['page_num']][1], '</small></b>',"\n";
    if (!$simple) {
        echo '                  </td>',"\n";
        if (isset($_SESSION['settings']['trash_folder']) &&
            $_SESSION['settings']['trash_folder'] == $hm_input['mailbox']) {
            echo '                 <td align="right" nowrap>
                 <input type="submit" value="',$str[20],'" class="button4" name="action">
                 </td>',"\n";
        }
        echo '                 <td align="right" nowrap>',"\n";
    }
    else {
        echo '<br>';
    }
    echo '                  <input class="button4" type="submit" name="toggle_all" ', 
         'value="',$str[246],'">&nbsp;&nbsp;
                      <select name="selection_type" class="select3">
                      <option class="option3" value="marked">',$str[6],'</option>
                      <option class="option3" value="page">',$str[7],'</option>
                      <option class="option3" value="all">',$str[8],'</option>
                  </select>&nbsp;
                  <input type="submit" class="button4" name="action" value="',$str[2],'">
                  <input type="submit" class="button4" name="action" value="',$str[3],'">
                  <input type="submit" class="button4" name="action" value="',$str[4],'">
                  &nbsp;<input type="submit" class="button4" name="action" value="',$str[1],'">-<input type="submit" class="button4" name="action" value="',$str[0],'">--&gt;
                  <select class="select3" name="destination">',"\n";
    hm_folder_options($dest, false, $simple, false, 'class="option3"');
    echo '                  </select>',"\n";
    if (!$simple) {
        echo '                  </td>
               </tr>
            </table>
            </td>
         </tr>
         <tr class="tables1">
            <td class="tables0">
            </td>
            <td width="49%" align="center">
            <small><b>',$str[21],'</b></small>
            </td>
            <td width="30%" align="center">',"\n";
        if (isset($_SESSION['settings']['sent_folder']) && 
             ($_SESSION['settings']['sent_folder'] == urldecode($hm_input['mailbox']))) {
            echo "            <b><small>",$str[25],"</small></b>\n";
        }
        else {
            echo "            <b><small>",$str[22],"</small></b>\n";
        }
        echo '            </td>
            <td width="15%" align="center">
            <b><small>',$str[23],'</small></b>
            </td>
            <td width="5%" align="center">
            <b><small>',$str[24],'</small></b>
            </td>
            <td width="1%" class="tables0">
            &nbsp;
            </td>
         </tr>',"\n";
    }
    else {
        echo '<br><table>';
    }
    for ($i=0;$i<$count;$i++) {
        if (!$simple) {
            echo "         <tr class=\"tables2\">\n";
        }
        /* content type */
        if (isset($headers[$sort_page[$i]][4])) {
            $content = $headers[$sort_page[$i]][4];
        }
        else {
            $content = '';
        }

        /* set defaults for unset fields */
        /* subject */
        if (!isset($headers[$sort_page[$i]][0]) ||
            trim($headers[$sort_page[$i]][0]) == '') {
            $subject = $str[229];
        }
        else {
            $subject = $headers[$sort_page[$i]][0];
        }

        /* from */
        if (!isset($headers[$sort_page[$i]][1]) ||
            trim($headers[$sort_page[$i]][1]) == '') {
            $from = $str[230];
        }
        else {
            $from = ltrim(str_replace('&quot;', '', $headers[$sort_page[$i]][1]));
            if (substr($from, 0, 4) != '&lt;') {
                $from = preg_replace("/&lt;.*&gt;/", '', $from);
            }
            else {
                $from = str_replace(array('&lt;', '&gt;'), '', $from);
            }
        }
        /* To */
        if (!isset($headers[$sort_page[$i]][6]) ||
            trim($headers[$sort_page[$i]][6]) == '') {
            $to = $str[232];
        }
        else {
            $to = ltrim(str_replace('&quot;', '', $headers[$sort_page[$i]][6]));
            if (substr($to, 0, 4) != '&lt;') {
                $to = preg_replace("/&lt;.*&gt;/", '', $to);
            }
            else {
                $to = str_replace(array('&lt;', '&gt;'), '', $to);
            }
        }
        /* date */
        if (!isset($headers[$sort_page[$i]][2]) ||
            trim($headers[$sort_page[$i]][2]) == '') {
            $date = $str[231];
        }
        else {
            $date = $headers[$sort_page[$i]][2];
            $year = substr($date, -2);
            if ($year == date('y')) {
                $date = substr($date, 0, -4);
            }
        }
        /* flags */
        if (isset($headers[$sort_page[$i]][5])) {
            $flags = $headers[$sort_page[$i]][5];
        }
        else {
            $flags = '';
        }
        /* unseen status */
        if (!stristr($flags, 'seen')) {
            $new = 1;
            $class = 'tables6';
            $font = 'font2';
        }
        else {
            $new = 0;
            $class = 'tables2';
            $font = 'font1';
        }
        /* size */
        if (isset($headers[$sort_page[$i]][7])) {
            $size = $headers[$sort_page[$i]][7];
        }
        else {
            $size = '';
        }
        /* print out a table row */
        if (!$simple) {
            echo '            <td width="1%" valign="top" class="tables0">';
        }
        else {
            echo '<tr><td>',"\n";
        }
        echo '
            <input type="checkbox" name="',$sort_page[$i], 
            '" value="mark" class="tables0" ';
        if (isset($hm_input['toggle_all'])) {
            if (!isset($_POST[$sort_page[$i]])) {
                echo 'CHECKED ';
            }
        }
        echo ">\n";
        if (!$simple) {
            echo '            </td>
            <td valign="top" class="',$class,'" width="48%">
            <table width="100%" cellpadding="0" cellspacing="0">
               <tr>
                  <td width="1%" nowrap valign="top">',"\n";
        }
        if (!empty($sort_info[3]) && isset($sort_info[3][$sort_page[$i]])) {
            if ($sort_info[3][$sort_page[$i]] > 1) {
                echo "                     ",str_repeat("&nbsp;&nbsp;&nbsp;",
                     $sort_info[3][$sort_page[$i]]),
                     "<font class=\"font2\">|_</font>&nbsp;\n";
            }
            else {
                echo "&nbsp;\n";
            }
        }
        $tag = 'mailbox='.urlencode($hm_input['mailbox']).'&amp;uid='.$sort_page[$i].
               '&amp;id='.urlencode($hm_input['id']).'&amp;new='.$new.
               '&amp;page_num='.$hm_input['page_num'];
        if (!$simple) {
            echo '                  </td>
                  <td valign="top">',"\n";
        }
        else {
            echo '</td><td>';
            if ($new == 1) {
                echo '[unread]';
            }
        }
        echo '                  <small><a class="',$font,'" href="message.php?',$tag,'">
                  ',$subject,'
                   </a></small>',"\n";
        if (!$simple) {
            echo '                  </td>
               </tr>
            </table>
            </td>
            <td class="',$class,'" width="30%" valign="top" nowrap>
            <table width="100%" cellpadding="0" cellspacing="0">
               <tr>
                  <td width="1%">
                  &nbsp;
                  </td>
                  <td valign="top">',"\n";
        }
        else {
            echo '</td><td>';
        }
        echo '                  <small>';
        if (!$simple) {
            echo '<a class="',$font,'" href="message.php?',$tag,'">';
        }
        if (isset($_SESSION['settings']['sent_folder']) &&
                 ($_SESSION['settings']['sent_folder'] == urldecode($hm_input['mailbox']))) {
            $to = trim($to);
            echo $to;
        }
        else {
            $from = trim($from);
            echo $from;
        }
        if ($simple) {
            echo '</small>',"\n";
            echo '</td><td>';
        }
        else {
            echo "\n",'                  </a></small>
                  </td>
               </tr>
            </table>
            </td>
            <td width="15%" valign="top" nowrap class="',$class,'">',"\n";
        }
        echo '            <small>&nbsp;'."\n";
        if (!$simple) {
            echo '            <a class="',$font,'" href="message.php?',$tag,'">';
        }
        echo htmlspecialchars($date, ENT_QUOTES, $str['charset']);
        if ($simple) {
            echo '</small>',"\n";
        }
        else {
            echo '</a></small>',"\n";
            echo '            </td>
            <td valign="top" class="',$class,'" width="5%" nowrap>',"\n";
        }
        echo '            <small>&nbsp;',"\n            ";
        if ($size != '') {
            $kb = intval($size/1024);
            if ($kb < 1) {
                echo $size," b\n";
            }
            elseif ($kb > 1000) {
                echo intval($kb/1024)," mb\n";
            }
            else {
                echo $kb," kb\n";
            }
        }
        echo "            &nbsp;</small>\n";
        if (!$simple) {
            echo "            </td>\n";
            /* multipart */
            echo '            <td class="tables0" align="center" width="1%" nowrap>';
            if (stristr($content, 'multipart')
                || stristr($content, 'mixed')) {
                echo "\n            <b><small>+&nbsp;</small></b>\n";
            }
            else {
                echo "\n            &nbsp;\n";
            }
            if (stristr($headers[$sort_page[$i]][5], 'answered')) {
                echo "\n            <b><small>r&nbsp;</small></b>\n";
            }
            echo "            </td>\n",
             "         </tr>\n";
        }
        else {
            echo '</td></tr>';
        }
    }
if (!$simple) {
    /* message controls */   
   echo '         <tr>
            <td colspan="6" align="right" class="tables0">
            <table width="100%" class="tables0" align="center" cellpadding="4" cellspacing="0">
               <tr>
                  <td nowrap>
                  <b><small>&nbsp;&nbsp;&nbsp;',$sort_info[0],' ',$str[18],
        ' &nbsp;&nbsp;',$str[19],' ',$sort_info[1][$hm_input['page_num']][0],' - ', 
        $sort_info[1][$hm_input['page_num']][1], '</small></b>
                  </td>',"\n";
    if (isset($_SESSION['settings']['trash_folder']) &&
        $_SESSION['settings']['trash_folder'] == $hm_input['mailbox']) {
        echo '                 <td align="right" nowrap>
                  <input type="submit" value="',$str[20],'" class="button4" name="action">
                  </td>';
    }
    echo '                  <td align="right" nowrap>
                  <input class="button4" type="submit" name="toggle_all" ', 
         'value="',$str[246],'">&nbsp;&nbsp;
                  <select name="selection_type2" class="select3">
                     <option class="option3" value="marked">',$str[6],'</option>
                     <option class="option3" value="page">',$str[7],'</option>
                     <option class="option3" value="all">',$str[8],'</option>
                  </select>&nbsp;
                  <input type="submit" class="button4" name="action2" value="',$str[2],'">
                  <input type="submit" class="button4" name="action2" value="',$str[3],'">
                  <input type="submit" class="button4" name="action2" value="',$str[4],'">
                  &nbsp;<input type="submit" class="button4" name="action2" value="',$str[1],'">-<input type="submit" class="button4" name="action2" value="',$str[0],'">--&gt;
                  <select class="select3" name="destination2">';
    hm_folder_options($dest, false, $simple, false, 'class="option3"');
    echo '                   </select>
                  </td>
               </tr>
            </table>
            </td>
         </tr>
      </table>
      </td>
   </tr>
   <tr>
      <td>
      <table width="100%" align="center" cellpadding="1" cellspacing="6" class="tables5">
         <tr>
            <td class="tables4" nowrap width="15%">
            &nbsp;&nbsp;<b>',$dsp_folders[urldecode($hm_input['mailbox'])],'</b>
            </td>
            <td class="tables1">
            &nbsp;&nbsp;',"\n";
    if ($hm_input['page_num'] > 0) {
        echo '            <input type=submit name="submit" ',
                              "class=\"button2\" value=\"<<<\">\n";
        $hm_input['prev'] = $hm_input['page_num'] - 1;
        echo '            <input type="hidden" name="prev" value="',$hm_input['prev'],'">
            <input type="hidden" name="id" value="',$hm_input['id'],'">
            <input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'">',"\n";
    }
    else {
        echo '            <input type="button" disabled="disabled" ',
                             "value=\"<<<\" class=\"button3\">\n";
    }
    echo '            <input type="submit" name="submit2" value="',$str[9],
        '" class="button2">
            <select name="page2">',"\n";
    foreach ($sort_info[1] as $index => $array) {
        echo "              <option value=\"$index\" ";
        if ($index == $hm_input['page_num']) {
            echo 'SELECTED';
        }
        echo " >",($index+1),"</option>\n";
    }
    echo "            </select>\n";
    if ($sort_info[0] > $sort_info[1][$hm_input['page_num']][1]) { 
        $next = $hm_input['page_num'] + 1;
        echo '            <input type="submit" name="submit" class="button2" ',
             'value=">>>">',"\n";
    }
    else {
        echo '            &nbsp;<input type="button" disabled="disabled" ',
                             "value=\">>>\" class=\"button3\">\n";
    }
    echo '            </td>
            <td align="right" width="15%" class="tables1" nowrap>
            <input type="submit" class="button2" name="action2" value="',$str[17],'">
            <select name="sort_type2">',"\n";
    if (isset($_SESSION['config']['client_sort']) && 
              $_SESSION['config']['client_sort'] == 'true') {
        $sort_types = $str['client_sort_types'];
    }
    foreach ($sort_types as $key => $value) {
        echo '               <option ';
        if ($sort == $key) {
            echo ' SELECTED ';
        }    
        echo "value=\"$key\">$value</option>\n";
    }
    echo '            </select>&nbsp;
            </td>
         </tr>';
    }
    else {
        echo '</table>';
    }
}
else {
    if (!$simple) {
        echo '<br>
<table align="center" class="tables3">
   <tr>
      <td height="20%" align="center">
      &nbsp;&nbsp;&nbsp;<b>', urldecode($hm_input['mailbox']),'
      </b> ',$str[54],'&nbsp;&nbsp;&nbsp;
      </td>
   </tr>',"\n";
    }
    else {
        echo urldecode($hm_input['mailbox']),' is empty';
    }
}
if (!$simple) {
echo '
      </table>
      </td>
   </tr>
</table>',"\n";
}
echo '</form>
</body>
</html>';

hm_imap_logout ($imap_stream);

?>
