<?php

/*  wrapper_functions.php: wrappers for various functions in lib/
*
    Copyright (C) 2002  Hastymail Development group

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; Version 2
    See the COPYING file for complete information.

* $Id: wrapper_functions.php,v 1.14 2003/10/06 04:30:21 sailfrog Exp $
*/

/* Include the needed files for the calling script */
require_once('constant.php');
require_once('session.php');
switch (basename($_SERVER['PHP_SELF'])) {
    case 'thread_view.php':
    case 'new.php':
    case 'mailbox.php':
        require_once('session_2.php');
        require_once('general.php');
        require_once('imap.php');
        require_once('imap_2.php');
        require_once('html_functions.php');
        break;
    case 'print_view.php':
    case 'message.php':
        require_once('session_2.php');
        require_once('general.php');
        require_once('imap.php');
        require_once('imap_2.php');
        require_once('bodystructure.php');
        require_once('html_functions.php');
        break;
    case 'search.php':
        require_once('general.php');
        require_once('imap.php');
        require_once('imap_2.php');
        require_once('html_functions.php');
        break;
    case 'redirect.php':
        break;
    case 'logout.php':
        require_once('session_2.php');
        break;
    case 'folders.php':
        require_once('general.php');
        require_once('imap.php');
        require_once('imap_2.php');
        require_once('imap_3.php');
        require_once('session_2.php');
        require_once('html_functions.php');
        break;
    case 'contacts.php':
    case 'options.php':
        require_once('../lang/lang_index.php');
        require_once('general.php');
        require_once('imap.php');
        require_once('session_2.php');
        require_once('html_functions.php');
        break;
    case 'about.php':
        require_once('general.php');
        require_once('imap.php');
        require_once('imap_3.php');
        require_once('html_functions.php');
        break;
    case 'iframe.php':
        break; 
    case 'compose.php':
        require_once('general.php');
        require_once('imap.php');
        require_once('imap_2.php');
        require_once('imap_3.php');
        require_once('session_2.php');
        require_once('smtp.php');
        require_once('html_functions.php');
        require_once('bodystructure.php');
        break;
    case 'download.php':
        require_once('general.php');
        require_once('imap.php');
        require_once('imap_2.php');
        require_once('bodystructure.php');
        break;
    default:
        hm_logged_out($hm_input['id']);
        break;
}

/* wrapper function to pull in contact lists from different sources.
   normal file based personal contacts are from hm_get_contacts().
   if an ldap_server entry is present in the hastymail.conf file then
   the defined ldap objects will be added to the contact list
*/
function hmw_get_contacts($user, $dir) {
    $contacts = array();
    if (isset($_SESSION['config']['ldap_server']) 
        && $_SESSION['config']['ldap_server'] != '') {
        $contacts = array_merge($contacts, hm_get_ldap_contacts());
    }
    $contacts = array_merge($contacts, hm_get_contacts($user, $dir));
    $contacts = hm_sort_contacts($contacts);
    return $contacts;
}

/* wraaper around get_sort_info(). checks for client sort from hastymail.conf
   and uses the appropriate function
*/
function hmw_get_sort_info ($imap_stream, $sort_type, $mailbox, $quick=false) {
    $sort_info = '';
    if (isset($_SESSION['config']['client_sort']) && 
              $_SESSION['config']['client_sort'] == 'true') {
        $sort_info = hm_client_side_sort($imap_stream, $mailbox, $sort_type);
    }
    else {
        $sort_info = hm_get_sort_info($imap_stream, $sort_type, $mailbox, $quick);
    }
    return $sort_info;
}

function hmw_crypt($string, $config, $type, $key) {
    if (isset($config['use_mcrypt']) && $config['use_mcrypt'] == 'true') {
        if (isset($config['mcrypt_cipher'])) {
            $cipher = strtolower($config['mcrypt_cipher']);
        }
        else {
            $cipher = 'des';
        }
        return hm_mcrypt($string, $type, $cipher, $key);
    }
    return hm_crypt($string, $key);
}

?>
